<template>
  <div>
    <ob-filters-from-to-date-type
        @changeHeight="onChangeHeight"
        :is-loader="isLoaderFilter"
        @update="onUpdateFilters"
    />
    <ob-table
        :columns="columnsActual"
        :items="items"
        :filter-buttons="tableFilterButtons"
        :functional-panel="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        :loading="isLoading"
        ref="spot-list-active-table"
        @select="onSelectTableRow"
        @on-change-filter-button="onChangeFilterButton"
    >
      <template #notification="{data}">
        <notificationSlot :item="data.item" />
      </template>
      <template #draftLifetime="{data}">
        <draftLifetimeSlot :item="data.item" />
      </template>
      <template #route="{data}">
        <routeSlot :item="data.item" />
      </template>
      <template #fromDt="{data}">
        <dateFromSlot :is-color="false" :item="data.item" />
      </template>
      <template #auctionType="{data}">
        <auctionTypeSlot :item="data.item" />
      </template>
      <template #currentPrice="{data}">
        <currentPriceSlot :item="data.item" />
      </template>
      <template #leadPartner="{data}">
        <leadPartnerSlot :item="data.item" />
      </template>
      <template #status="{data}">
        <statusSlot
            :item="data.item"
            :type-auction="'spot-list'"
            @assignTo="onOpenModal('assign', data.item)"
            @remove="onOpenModal('remove', data.item)"
            @copy="onCopyItemInfo(data.item)"
        />
      </template>
    </ob-table>

    <ob-modal
        ref="assignWinnerModal"
        :title="modalTitle"
        :is-show-controls="true"
        :is-error="modal[typeModal].isError"
        :size="modal[typeModal].size"
        :okText="modal[typeModal].okText"
        :cancelText="modal[typeModal].cancelText"
        custom-class="spot-winner-modal"
        @submit="modal[typeModal].methods()"
    >
      <SpotAssignWinnerModal
          v-if="typeModal === 'assign'"
          :selectedItem="selectedItem"
          :winnerItem="winnerItem"
      />
      <p v-if="typeModal === 'remove'">Вы уверены, что хотите отменить спот-аукцион?</p>
    </ob-modal>
  </div>
</template>

<script>
import api from '@/api'
import { uuid } from 'vue-uuid'
import ObTable from 'common-components/src/obComponents/obTable'
import ObModal from 'common-components/src/obComponents/obModal/index'
import SpotAssignWinnerModal from '@/pages/spotPage/spotAssignWinnerModal'
import ObFiltersFromToDateType from '@/components/ObFiltersFromToDateType'
import routeSlot from './slots/route'
import dateFromSlot from './slots/dateFrom'
import notificationSlot from './slots/notification'
import draftLifetimeSlot from './slots/draftLifetime'
import auctionTypeSlot from './slots/auctionType'
import currentPriceSlot from './slots/currentPrice'
import statusSlot from './slots/status'
import leadPartnerSlot from './slots/leadPartner'
import { mapGetters, mapMutations } from 'vuex'

export default {
  name: 'spotListActualClient',
  components: {
    ObTable,
    ObModal,
    SpotAssignWinnerModal,
    ObFiltersFromToDateType,
    routeSlot,
    dateFromSlot,
    notificationSlot,
    draftLifetimeSlot,
    auctionTypeSlot,
    currentPriceSlot,
    leadPartnerSlot,
    statusSlot
  },
  data () {
    return {
      isOpenFilters: true,
      typeModal: 'remove',
      modal: {
        remove: {
          isError: true,
          size: 'small',
          okText: 'Отменить',
          cancelText: 'Не отменять',
          methods: this.onRemoveItem
        },
        assign: {
          isError: false,
          size: 'small',
          okText: 'Назначить',
          cancelText: 'Отмена',
          methods: this.onAssignTo
        }
      },
      spotTimer: null,
      auctionTimer: null,
      isLoaderFilter: false,
      selectedItem: {},
      winnerItem: {},
      columnsActual: [
        {
          title: '',
          key: 'notification',
          slotName: 'notification',
          width: '16'
        },
        {
          title: '№ спота',
          key: 'number',
          width: 145
        },
        {
          title: 'Актуальность',
          key: 'draftLifetime',
          slotName: 'draftLifetime'
        },
        {
          title: 'Маршрут',
          key: 'startAddress',
          width: '285',
          slotName: 'route'
        },
        {
          title: 'Дата погрузки',
          key: 'fromDt',
          slotName: 'fromDt'
        },
        {
          title: 'Тип ТС',
          key: 'resourceTypeTitle',
          width: 180
        },
        {
          title: 'Тип аукциона',
          key: 'auctionType',
          slotName: 'auctionType',
          width: 60
        },
        {
          title: 'Текущая ставка без НдС',
          key: 'currentPrice',
          slotName: 'currentPrice',
          width: 110
        },
        {
          title: 'Лидирующий контрагент',
          key: 'leadPartner',
          slotName: 'leadPartner',
          action: true,
          width: 150
        },
        {
          title: 'Статус',
          key: 'status',
          slotName: 'status',
          action: true,
          exactWidth: '103px'
        }
      ],
      tableFilterButtons: [
        {
          type: 'ALL',
          title: 'Все',
          _isActive: true
        },
        {
          type: 'ENDS',
          html: '<i class="icon clock -light-raspberry-red"></i>',
          _isActive: false
        },
        {
          type: 'IN_PROCCESS',
          title: 'Опубликован',
          _isActive: false
        },
        {
          type: 'AUCTION_ENDED',
          title: 'Подведение итогов',
          _isActive: false
        },
        {
          type: 'EXCLAMATION_MARK',
          html: '<i class="icon important -light-raspberry-red"></i>',
          _isActive: false
        }
      ],
      auctionState: 'ALL',
      auctionType: null,
      items: [],
      isLoading: true
    }
  },
  created () {
    this.getSpotList()
  },
  computed: {
    ...mapGetters({
      spotClientFilter: 'spot/clientFilter'
    }),
    tableHeight () {
      if (this.isOpenFilters) {
        return window.innerHeight - 630
      }
      return window.innerHeight - 355
    },
    modalTitle () {
      if (this.typeModal === 'assign') {
        return `Назначение победителя в споте ${this.selectedItem.number}`
      } else {
        return 'Отмена спота'
      }
    }
  },
  beforeDestroy () {
    this.setSpotClientFilter({})
    clearTimeout(this.spotTimer)
    clearTimeout(this.auctionTimer)
  },
  mounted() {
    if (this.$route.query.auctionState && this.$route.query.auctionState !== 'ALL') {
      let tab = this.tableFilterButtons.find((key) => {
        if (key.type === this.$route.query.auctionState) {
          return key
        }
      });
      this.onChangeFilterButton(tab);
    }
  },
  methods: {
    ...mapMutations({
      setSpotClientFilter: 'spot/SET_SPOT_CLIENT_FILTER',
      setSpotNumber: 'spot/SET_SPOT_NUMBER'
    }),
    getSpotList () {
      clearTimeout(this.spotTimer)
      clearTimeout(this.auctionTimer)

      const postData = {
        tabType: 'actual',
        sortField: 'updated_at',
        sortDirection: 'desc',
        ...this.spotClientFilter
      }

      api.spotAuction.getSpotListByTab({ postData })
         .then(responseSpot => {
           const auctionsUuidList = new Set(responseSpot.content.map(item => item.auctionUuid))
           if ([...auctionsUuidList].length) {
             this.getAuctionList(responseSpot.content, [...auctionsUuidList], this.auctionType, this.auctionState)
           } else {
             this.items = []
             this.isLoading = false
             this.isLoaderFilter = false
           }
           this.spotTimer = setTimeout(this.getSpotList.bind(null), 25000)
         })
         .catch(e => {
           console.error(e)
           clearTimeout(this.spotTimer)
           clearTimeout(this.auctionTimer)
           this.$notification({
             type: 'system_notification_error',
             message: 'Ошибка загрузки данных (спотов)'
           })
         })
    },
     getAuctionList (spotList, auctionList, type, auctionState) {
      api.spotAuction
        .getAuctionInfo({
          list: auctionList,
          type: type,
          auctionState: auctionState
        })
        .then((responseAuction) => {
          this.items = []
          let tmpItems = this.preprocessTableData(
            spotList,
            responseAuction.list
          )

          tmpItems.forEach((tmpItem) => {
            responseAuction.list.forEach((auctionItem) => {
              if (tmpItem.auctionUuid === auctionItem.auctionUuid) {
                this.items.push(tmpItem)
              }
            })
          })

          this.isLoading = false
          this.isLoaderFilter = false
          this.auctionTimer = setTimeout(this.getAuctionList.bind(null, spotList, auctionList, this.auctionType, this.auctionState), 5000)
        })
        .catch(e => {
           console.error(e)
           clearTimeout(this.auctionTimer)
           this.$notification({
             type: 'system_notification_error',
             message: 'Ошибка загрузки данных (аукционов)'
           })
         })
    },
    preprocessTableData (spot, auction) {
      const auctionHash = auction.reduce((acc, item) => {
        acc[item.auctionUuid] = item
        return acc
      }, {})

      return spot.map((item) => {
        if (auctionHash.hasOwnProperty(item.auctionUuid)) {
          return {
            ...item,
            actualTime: auctionHash[item.auctionUuid].actualTime,
            auctionStatus: auctionHash[item.auctionUuid].auctionStatus,
            carrier: auctionHash[item.auctionUuid].carrier,
            currentPrice: auctionHash[item.auctionUuid].currentPrice,
            endPlanDt: auctionHash[item.auctionUuid].endPlanDt,
            exclamationMark: auctionHash[item.auctionUuid].exclamationMark,
            startPlanDt: auctionHash[item.auctionUuid].startPlanDt,
            auctionType: auctionHash[item.auctionUuid].type
          }
        } else {
          return item
        }
      })
    },
    async onOpenModal (type, row) {
      this.selectedItem = row
      this.typeModal = type
      if (this.typeModal === 'assign') {
        try { 
          const parentEntity = await api.spotAuction.getParticipantList(this.selectedItem.uuid)
          const winnerClient = await api.spotAuction.assignWinnerClient(parentEntity.data.parentEntityUuid, parentEntity.data.totalPrice)
          this.winnerItem = winnerClient.data
          this.$refs.assignWinnerModal.open()
        }
        catch(e) {
          console.error(e)
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных',
          })
        }
      } else {
         this.$refs.assignWinnerModal.open()
      }
    },
    async onAssignTo () {
      try { 
        await api.spotAuction.setWinningCarrier(this.selectedItem.uuid, this.winnerItem.bidUuid)
        this.getSpotList()
        this.$refs.assignWinnerModal.close()
      }
      catch(e) {
        console.error(e)
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        })
      }
    },
    onCopyItemInfo (row) {
      let notificationId = new Date().getTime() + '_copy'
      this.$notification({
        type: 'system_notification_in_load',
        message: 'Копировать',
        id: notificationId
      })
      setTimeout(() => {
        this.$notification({ event: 'close', id: notificationId })
      }, 1000)
      this.$router.push({ name: 'spot__draft__item__final', params: { uuid: uuid.v4(), id: 'created', rowUuid: row.uuid } })
    },
    onRemoveItem () {
      api.spotAuction
         .cancelSpotOrder(this.selectedItem.uuid)
         .then(() => {
           this.getSpotList()

           this.$refs.assignWinnerModal.close()
           this.selectedItem = {}

           const notificationId = new Date().getTime() + '_cancel'
           this.$notification({
             type: 'snackbars',
             id: notificationId,
             message: 'Спот отменен и переведен в раздел "Завершенные"'
           })
           setTimeout(() => {
             this.$notification({ event: 'close', id: notificationId })
           }, 5000)
         })
         .catch(e => {
           console.error(e);
           this.$notification({
             type: "system_notification_error",
             message: "Ошибка отмены"
           });
         })
    },
    onUpdateFilters (filter) {
      this.setSpotClientFilter(filter)
      this.getSpotList()
      this.isLoaderFilter = true
    },
    onSelectTableRow (row) {
      this.$router.push({ name: 'spot__item', params: { uuid: row.uuid, status: row.orderStatus } })
    },
    onChangeHeight () {
      this.isOpenFilters = !this.isOpenFilters
    },
    onChangeFilterButton (e) {
      this.tableFilterButtons.map((button) => (button._isActive = false));
      this.$router.push({
        query: {
          ...this.$route.query,
          auctionState: e.type
        }
      }).catch(() => {});
      e._isActive = true;
      this.auctionState = e.type;
      this.getSpotList();
    }
  }
}
</script>

<style lang="scss">
@import '~common-components/src/static/css/variables';
.spot-winner-modal {
  width: 585px !important;
  .ob-button-container.primary-type,
  .ob-button-container.flat-type {
     border-radius: 10px;
  }
  .ob-button-container.primary-type {
    color: $style-white !important;
    background: $color-blue-navy-blue !important;
  }
}

.ob-modal-container {
  .modal-small {
    width: 585px !important;
  }
}
</style>

